using System;
using System.Drawing;
using System.Collections;
using System.Text;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using org.bouncycastle.util;
using org.bouncycastle.util.encoders;
using org.bouncycastle.crypto;
using org.bouncycastle.crypto.paddings;
using org.bouncycastle.crypto.engines;
using org.bouncycastle.crypto.modes;
using org.bouncycastle.crypto.parameters;

namespace CBCBlockCipherTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtKey;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtPlainText;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.RadioButton radioButtonDES;
		private System.Windows.Forms.RadioButton radioButtonDESede;
		private System.Windows.Forms.RadioButton radioButtonIDEA;
		private System.Windows.Forms.RadioButton radioButtonRijindael;
		private System.Windows.Forms.RadioButton radioButtonTwoFish;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtName;
		private System.Windows.Forms.Label lblMessage;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox txtCipherText;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox txtDecryptText;

		//private bool doneEncrypt = false;

		private String key = "0123456789abcdef0123456789abcdef";
		private String plainText = "www.bouncycastle.org";
		//private byte[] keyBytes = null;
		private byte[] cipherText = null;
		private BufferedBlockCipher cipher = null;
		private System.Windows.Forms.Button buttonRun;

		private String[] cipherNames = { "DES", "DESede", "IDEA", 
										   "Rijndael", "Twofish" };

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			txtKey.Text = key;
			txtPlainText.Text = plainText;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.txtKey = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtPlainText = new System.Windows.Forms.TextBox();
			this.radioButtonDES = new System.Windows.Forms.RadioButton();
			this.radioButtonDESede = new System.Windows.Forms.RadioButton();
			this.radioButtonIDEA = new System.Windows.Forms.RadioButton();
			this.radioButtonRijindael = new System.Windows.Forms.RadioButton();
			this.radioButtonTwoFish = new System.Windows.Forms.RadioButton();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.txtName = new System.Windows.Forms.TextBox();
			this.lblMessage = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.txtCipherText = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.txtDecryptText = new System.Windows.Forms.TextBox();
			this.buttonRun = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(40, 192);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Key";
			// 
			// txtKey
			// 
			this.txtKey.Location = new System.Drawing.Point(136, 192);
			this.txtKey.Name = "txtKey";
			this.txtKey.Size = new System.Drawing.Size(456, 22);
			this.txtKey.TabIndex = 1;
			this.txtKey.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(40, 160);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(96, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "Plain text";
			// 
			// txtPlainText
			// 
			this.txtPlainText.Location = new System.Drawing.Point(136, 152);
			this.txtPlainText.Name = "txtPlainText";
			this.txtPlainText.Size = new System.Drawing.Size(456, 22);
			this.txtPlainText.TabIndex = 3;
			this.txtPlainText.Text = "";
			// 
			// radioButtonDES
			// 
			this.radioButtonDES.Location = new System.Drawing.Point(80, 40);
			this.radioButtonDES.Name = "radioButtonDES";
			this.radioButtonDES.Size = new System.Drawing.Size(112, 32);
			this.radioButtonDES.TabIndex = 4;
			this.radioButtonDES.Text = "DES Engine";
			// 
			// radioButtonDESede
			// 
			this.radioButtonDESede.Location = new System.Drawing.Point(224, 40);
			this.radioButtonDESede.Name = "radioButtonDESede";
			this.radioButtonDESede.Size = new System.Drawing.Size(112, 32);
			this.radioButtonDESede.TabIndex = 5;
			this.radioButtonDESede.Text = "DES ede Engine";
			// 
			// radioButtonIDEA
			// 
			this.radioButtonIDEA.Location = new System.Drawing.Point(360, 40);
			this.radioButtonIDEA.Name = "radioButtonIDEA";
			this.radioButtonIDEA.Size = new System.Drawing.Size(112, 32);
			this.radioButtonIDEA.TabIndex = 6;
			this.radioButtonIDEA.Text = "IDEA Engine";
			// 
			// radioButtonRijindael
			// 
			this.radioButtonRijindael.Location = new System.Drawing.Point(80, 88);
			this.radioButtonRijindael.Name = "radioButtonRijindael";
			this.radioButtonRijindael.Size = new System.Drawing.Size(112, 32);
			this.radioButtonRijindael.TabIndex = 7;
			this.radioButtonRijindael.Text = "Rijndael Engine";
			// 
			// radioButtonTwoFish
			// 
			this.radioButtonTwoFish.Checked = true;
			this.radioButtonTwoFish.Location = new System.Drawing.Point(224, 88);
			this.radioButtonTwoFish.Name = "radioButtonTwoFish";
			this.radioButtonTwoFish.Size = new System.Drawing.Size(112, 32);
			this.radioButtonTwoFish.TabIndex = 8;
			this.radioButtonTwoFish.TabStop = true;
			this.radioButtonTwoFish.Text = "Twofish Engine";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 16);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(152, 24);
			this.label3.TabIndex = 10;
			this.label3.Text = "Select engine";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(32, 224);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(104, 16);
			this.label4.TabIndex = 11;
			this.label4.Text = "Alogrithm Name";
			// 
			// txtName
			// 
			this.txtName.Location = new System.Drawing.Point(136, 232);
			this.txtName.Name = "txtName";
			this.txtName.Size = new System.Drawing.Size(456, 22);
			this.txtName.TabIndex = 12;
			this.txtName.Text = "";
			// 
			// lblMessage
			// 
			this.lblMessage.ForeColor = System.Drawing.Color.Red;
			this.lblMessage.Location = new System.Drawing.Point(32, 376);
			this.lblMessage.Name = "lblMessage";
			this.lblMessage.Size = new System.Drawing.Size(456, 16);
			this.lblMessage.TabIndex = 13;
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(32, 264);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(96, 16);
			this.label5.TabIndex = 14;
			this.label5.Text = "Cipher text";
			// 
			// txtCipherText
			// 
			this.txtCipherText.Location = new System.Drawing.Point(136, 264);
			this.txtCipherText.Name = "txtCipherText";
			this.txtCipherText.Size = new System.Drawing.Size(456, 22);
			this.txtCipherText.TabIndex = 15;
			this.txtCipherText.Text = "";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(32, 304);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(96, 16);
			this.label6.TabIndex = 16;
			this.label6.Text = "Decrypt text";
			// 
			// txtDecryptText
			// 
			this.txtDecryptText.Location = new System.Drawing.Point(136, 304);
			this.txtDecryptText.Name = "txtDecryptText";
			this.txtDecryptText.Size = new System.Drawing.Size(456, 22);
			this.txtDecryptText.TabIndex = 17;
			this.txtDecryptText.Text = "";
			// 
			// buttonRun
			// 
			this.buttonRun.Location = new System.Drawing.Point(136, 336);
			this.buttonRun.Name = "buttonRun";
			this.buttonRun.Size = new System.Drawing.Size(104, 24);
			this.buttonRun.TabIndex = 18;
			this.buttonRun.Text = "Run";
			this.buttonRun.Click += new System.EventHandler(this.buttonRun_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(720, 396);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.buttonRun,
																		  this.txtDecryptText,
																		  this.label6,
																		  this.txtCipherText,
																		  this.label5,
																		  this.lblMessage,
																		  this.txtName,
																		  this.label4,
																		  this.label3,
																		  this.radioButtonTwoFish,
																		  this.radioButtonRijindael,
																		  this.radioButtonIDEA,
																		  this.radioButtonDESede,
																		  this.radioButtonDES,
																		  this.txtPlainText,
																		  this.label2,
																		  this.txtKey,
																		  this.label1});
			this.Name = "Form1";
			this.Text = "CBC Block Cipher Test";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private byte[] performEncrypt(byte[] key, String plainText)
		{

			byte[]  ptBytes = getBytes(plainText);
			cipher = new PaddedBufferedBlockCipher(
				new CBCBlockCipher(getEngineInstance()));

			String name = cipher.getUnderlyingCipher().getAlgorithmName();
			txtName.Text = name;
			cipher.init(true, new KeyParameter(key));

			byte[] rv = new byte[cipher.getOutputSize(ptBytes.Length)];

			int oLen = cipher.processBytes(ptBytes, 0, ptBytes.Length, rv, 0);
			try
			{
				cipher.doFinal(rv, oLen);
			}
			catch (CryptoException ce)
			{
				lblMessage.Text = "Encrypt exception: " + ce.ToString();
			}
			return rv;
		}

		private String performDecrypt(byte[] key, byte[] cipherText)
		{
			cipher.init(false, new KeyParameter(key));

			byte[] rv = new byte[cipher.getOutputSize(cipherText.Length)];

			int oLen = cipher.processBytes(cipherText, 0, cipherText.Length, rv, 0);
			try
			{
				cipher.doFinal(rv, oLen);
			}
			catch (CryptoException ce)
			{
				lblMessage.Text = "Decrypt exception: " + ce.ToString();
			}
			return ByteArray2String(rv).Trim();
			//return new String(rv).Trim();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		
		}
		private int whichCipher()
		{
			if (radioButtonDES.Checked)
				return 0;
			else if (radioButtonDESede.Checked)
				return 1;
			else if (radioButtonIDEA.Checked)
				return 2;
			else if (radioButtonRijindael.Checked)
				return 3;
			else if (radioButtonTwoFish.Checked)
				return 4;
			else
				return 0; // DES
		}

		private BlockCipher getEngineInstance()
		{
			// returns a block cipher according to the current
			// state of the radio button lists.  This is only
			// done prior to encryption.
			BlockCipher rv = null;

			switch (whichCipher())
			{
				case 0:
					rv = new DESEngine();
					break;
				case 1:
					rv = new DESedeEngine();
					break;
				case 2:
					rv = new IDEAEngine();
					break;
				case 3:
					rv = new RijndaelEngine();
					break;
				case 4:
					rv = new TwofishEngine();
					break;
				default:
					rv = new DESEngine();
					break;
			}
			return rv;
		}

		private byte [] getBytes(String str)
		{
			char[]  cs = str.ToCharArray();
			byte[]  bs = new byte[cs.Length];

			for (int i = 0; i != cs.Length; i++)
			{
				bs[i] = Convert.ToByte(cs[i]);
			}
			return bs;
		}

		private String ByteArray2String(byte[] bs)
		{
			StringBuilder s = new StringBuilder();
			for (int i = 0; i < bs.Length; i++) 
			{
				s.Append(Convert.ToChar(bs[i]));
			}
			return s.ToString();
		}

		private void buttonRun_Click(object sender, System.EventArgs e)
		{
			key = txtKey.Text;
			plainText = txtPlainText.Text;

			cipherText = performEncrypt(Hex.decode(getBytes(key)), plainText);
			String cts = ByteArray2String(Hex.encode(cipherText));
			txtCipherText.Text = cts;

			String decryptText = performDecrypt(Hex.decode(getBytes(key)), cipherText);
			txtDecryptText.Text = decryptText;

			if (decryptText.CompareTo(plainText) == 0)
			{
				lblMessage.Text = "Success";
			}
			else
			{
				lblMessage.Text = "Failure";
			}
		
		}
	}
}
