using System;
using System.IO;
using org.bouncycastle.asn1;
using org.bouncycastle.asn1.util;
using org.bouncycastle.util.encoders;
using org.bouncycastle.util.test;

namespace asn1.test
{
	/**
	 * X.690 test example
	 */
	public class OIDTest: Test
	{
		byte[]	req = Hex.decode("0603813403");

		public String getName()
		{
			return "OID";
		}
	
		public TestResult perform()
		{
			try
			{
//				MemoryStream	bIn = new MemoryStream(req);
//				DERInputStream			dIn = new DERInputStream(bIn);

				DERObjectIdentifier 	o = new DERObjectIdentifier("2.100.3");

				MemoryStream	bOut = new MemoryStream();
				DEROutputStream			dOut = new DEROutputStream(bOut);

				dOut.writeObject(o);

				byte[]					bytes = bOut.ToArray();

				if (bytes.Length != req.Length)
				{
					return new SimpleTestResult(false, getName() + ": failed length test");
				}

				for (int i = 0; i != req.Length; i++)
				{
					if (bytes[i] != req[i])
					{
						return new SimpleTestResult(false, getName() + ": failed comparison test");
					}
				}
			}
			catch (Exception e)
			{
				return new SimpleTestResult(false, getName() + ": Exception - " + e.ToString());
			}

			return new SimpleTestResult(true, getName() + ": Okay");
		}

		[STAThread]
		static void Main(string[] args)
		{
			Test    test = new OIDTest();
			TestResult  result = test.perform();
			Console.WriteLine(result.ToString());
		}
	}
}
