
using System;
//using System.Collections;
//using org.bouncycastle.io;
using org.bouncycastle.asn1;

namespace org.bouncycastle.asn1.x509
{
	public class AttCertIssuer: DEREncodable
	{
		DEREncodable    obj;
		DERObject       choiceObj;

		public AttCertIssuer(
			V2Form  v2Form)
		{
			obj = v2Form;
			choiceObj = new DERTaggedObject(true, 0, obj);
		}

		/**
		 * <pre>
		 *  AttCertIssuer ::= CHOICE {
		 *       v1Form   GeneralNames,  -- MUST NOT be used in this
		 *                               -- profile
		 *       v2Form   [0] V2Form     -- v2 only
		 *  }
		 * </pre>
		 */
		public DERObject getDERObject()
		{
			return choiceObj;
		}
	}

}